﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using HeuristicLab.Common;
using HeuristicLab.Problems.GrammaticalOptimization;

namespace HeuristicLab.Algorithms.Bandits.GrammarPolicies {
  public class RandomNoResamplingPolicy : IGrammarPolicy {

    private readonly Dictionary<ReadonlySequence, bool> done;
    private readonly Dictionary<Tuple<ReadonlySequence, ReadonlySequence>, ReadonlySequence> nextState;


    public RandomNoResamplingPolicy() {
      this.done = new Dictionary<ReadonlySequence, bool>();
    }

    public ReadonlySequence SelectAction(Random random, ReadonlySequence state, IEnumerable<ReadonlySequence> actions) {
      var allDone = true;
      foreach (var a in actions) {
        var p = Tuple.Create(state, a);
        allDone &= nextState.ContainsKey(p) && Done(nextState[p]);
        if (!allDone) break;
      }
      if(allDone)
      return actions
        .Where(a => !nextState.ContainsKey(Tuple.Create(state, a)) || Done(nextState[Tuple.Create(state, a)]))
        .SelectRandom(random);
    }

    public void UpdateReward(ReadonlySequence state, ReadonlySequence action, double reward, ReadonlySequence newState) {
      var key = Tuple.Create(state, action);
      nextState[key] = newState;
      if (newState.IsTerminal) done[newState] = true;
      if 
    }

    public bool Done(ReadonlySequence state) {
      return done.ContainsKey(state);
    }
  }
}
